#
# This Makefile was automatically generated; do not edit.
# Generated on 'swio-display-x64-rhel04-15' on Thu Oct 8 14:26:12 PDT 2015.
#

#
# KBUILD common Makefile fragment for NVIDIA Linux kernel modules.
#
# This file contains common Makefile rules and definitions which are shared
# between the build systems for various Linux kernel modules included as part
# of the NVIDIA Linux driver.
#
# kbuild Makefile originally developed by:
#
# Alistair J Strachan (alistair@devzero.co.uk) (first pass, enhancements)
# Christian Zander (zander@mail.minion.de) (enhancements
#

.PHONY: all install suser-sanity-check rmmod-sanity-check build-sanity-checks \
module module-sign module-install package-install clean

all: install
install: package-install

#
# The precompiled kernel module build process requires a separation of the
# closed source and open source object files.
#

KERNEL_GLUE_NAME := nv-linux$(NV_MODULE_SUFFIX).o
KERNEL_GLUE_OBJS := $(MODULE_GLUE_OBJS) $(MODULE_NAME).mod.o

obj-m := $(addsuffix .o,$(MODULE_NAME))

#
# Include local source directory in $(CC)'s include path and set disable any
# warning types that are of little interest to us.
#

EXTRA_CFLAGS += -I$(src)
EXTRA_CFLAGS += -Wall -MD $(DEFINES) $(INCLUDES) -Wsign-compare -Wno-cast-qual -Wno-error

#
# Output directory for the build; default to the source directory if not set.
# The source directory should be set by the including Makefile, but set it
# to a reasonable default here, just in case.
#

src ?= .
obj ?= $(src)

#
# Determine location of the Linux kernel source tree. Allow users to override
# the default (i.e. automatically determined) kernel source location with the
# SYSSRC directive; this new directive replaces NVIDIA's SYSINCLUDE.
#

ifdef SYSSRC
 KERNEL_SOURCES := $(SYSSRC)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
else
 KERNEL_UNAME ?= $(shell uname -r)
 KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
 KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
 KERNEL_HEADERS := $(KERNEL_SOURCES)/include
endif

KERNEL_OUTPUT := $(KERNEL_SOURCES)
KBUILD_PARAMS :=

ifdef SYSOUT
 ifneq ($(SYSOUT), $(KERNEL_SOURCES))
 KERNEL_OUTPUT := $(SYSOUT)
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
else
 KERNEL_UNAME ?= $(shell uname -r)
 KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
 ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
 KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
 KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
 endif
endif

CC ?= cc
HOST_CC ?= $(CC)
LD ?= ld

ifndef ARCH
 ARCH := $(shell uname -m | sed -e 's/i.86/i386/' \
 -e 's/armv[0-7]\w\+/arm/' \
 -e 's/aarch64/arm64/' \
 -e 's/ppc64le/powerpc/' \
 )
endif

CONFTEST := /bin/sh $(src)/conftest.sh "$(CC)" "$(HOST_CC)" $(ARCH) $(KERNEL_SOURCES) $(KERNEL_OUTPUT)

CONFTEST_CFLAGS := $(shell $(CONFTEST) build_cflags)

KERNEL_UNAME ?= $(shell $(CONFTEST) get_uname)
MODULE_ROOT := /lib/modules/$(KERNEL_UNAME)/kernel/drivers

#
# Sets any internal variables left unset by KBUILD (e.g. this happens during
# a top-level run).
#

TOPDIR ?= $(KERNEL_SOURCES)

#
# Linux 2.6 uses the .ko module extension.
#

MODULE_OBJECTS := $(addsuffix .ko,$(MODULE_NAME))

#
# NVIDIA specific CFLAGS and #define's.
#

EXTRA_CFLAGS += -D__KERNEL__ -DMODULE -DNVRM -DNV_VERSION_STRING=\"352.55\" -Wno-unused-function -Wuninitialized -fno-strict-aliasing -mno-red-zone -mcmodel=kernel -DNV_UVM_ENABLE

#
# Detect SGI UV systems and apply system-specific optimizations.
#
ifneq ($(wildcard /proc/sgi_uv),)
 EXTRA_CFLAGS += -DNV_CONFIG_X86_UV
endif

#
# Command for signing kernel modules
#

MOD_SIGN_CMD ?= $(KERNEL_SOURCES)/scripts/sign-file

#
# Miscellaneous NVIDIA kernel module build support targets. They are needed
# to satisfy KBUILD requirements and to support NVIDIA specifics.
#

$(obj)/$(CORE_OBJS):
	@cp $(src)/$(CORE_OBJS) $(obj)/$(CORE_OBJS)

$(obj)/$(VERSION_HEADER):
	@echo \#define NV_COMPILER \"`$(CC) -v 2>&1 | tail -n 1`\" > $@

CONFTEST_COMPILE_TEST_HEADERS := $(obj)/conftest/macros.h \
$(obj)/conftest/functions.h $(obj)/conftest/symbols.h $(obj)/conftest/types.h \
$(obj)/conftest/generic.h

CONFTEST_HEADERS := $(obj)/conftest/patches.h $(obj)/conftest/headers.h \
$(CONFTEST_COMPILE_TEST_HEADERS)

#
# Generate a header file for a single conftest compile test. Each compile test
# header depends on conftest.sh, as well as the generated conftest/headers.h
# file, which is included in the compile test preamble.
#

$(obj)/conftest/compile-tests/%.h: $(src)/conftest.sh $(obj)/conftest/headers.h
	@mkdir -p $(obj)/conftest/compile-tests
	@$(CONFTEST) compile_tests '$(CONFTEST_CFLAGS)' $(notdir $*) > $@

#
# Concatenate a conftest/*.h header from its constituent compile test headers
#
# $(1): The name of the concatenated header
# $(2): The list of compile tests that make up the header
#

define GENERATE_COMPILE_TEST_HEADER
$(obj)/conftest/$(1).h: $(addprefix $(obj)/conftest/compile-tests/,$(addsuffix .h,$(2)))
	@mkdir -p $(obj)/conftest
	@# concatenate /dev/null to prevent cat from hanging when $$^ is empty
	@cat $$^ /dev/null > $$@
endef

#
# Generate the conftest compile test headers from the lists of compile tests
# provided by the module-specific makefile.
#

$(eval $(call GENERATE_COMPILE_TEST_HEADER,functions,$(FUNCTION_COMPILE_TESTS)))
$(eval $(call GENERATE_COMPILE_TEST_HEADER,generic,$(GENERIC_COMPILE_TESTS)))
$(eval $(call GENERATE_COMPILE_TEST_HEADER,macros,$(MACRO_COMPILE_TESTS)))
$(eval $(call GENERATE_COMPILE_TEST_HEADER,symbols,$(SYMBOL_COMPILE_TESTS)))
$(eval $(call GENERATE_COMPILE_TEST_HEADER,types,$(TYPE_COMPILE_TESTS)))

$(obj)/conftest/patches.h: $(src)/conftest.sh
	@mkdir -p $(obj)/conftest
	@$(CONFTEST) patch_check > $@

$(obj)/conftest/headers.h: $(src)/conftest.sh
	@mkdir -p $(obj)/conftest
	@$(CONFTEST) test_kernel_headers > $@

$(obj)/nv.o: $(obj)/$(VERSION_HEADER)

#
# KBUILD build parameters.
#

ifndef NV_VERBOSE
 ifneq ($(strip $(QUIET)),1)
 NV_VERBOSE=1
 else
 NV_VERBOSE=0
 endif
endif

KBUILD_PARAMS += KBUILD_VERBOSE=$(NV_VERBOSE)
KBUILD_PARAMS += -C $(KERNEL_SOURCES) SUBDIRS=$(PWD)
KBUILD_PARAMS += ARCH=$(ARCH)

#
# NVIDIA sanity checks.
#

suser-sanity-check:
	@if ! $(CONFTEST) suser_sanity_check; then exit 1; fi

rmmod-sanity-check:
	@if ! $(CONFTEST) rmmod_sanity_check; then exit 1; fi

BUILD_SANITY_CHECKS = \
	cc_version_check \
	rivafb_sanity_check \
	nvidiafb_sanity_check \
	dom0_sanity_check \
	xen_sanity_check \
	preempt_rt_sanity_check

build-sanity-checks:
	@for SANITY_CHECK in $(BUILD_SANITY_CHECKS); do \
	 if ! $(CONFTEST) $$SANITY_CHECK full_output; then \
	 exit 1; \
	 fi; \
	done

#
# Call into KBUILD to build the NVIDIA kernel module(s) defined in $(obj-m)
#

module: build-sanity-checks $(CONFTEST_HEADERS)
	@echo "NVIDIA: calling KBUILD..."; \
	$(MAKE) "CC=$(CC)" $(KBUILD_PARAMS) modules; \
	echo "NVIDIA: left KBUILD."; \
	for module in $(MODULE_OBJECTS); do \
	if ! [ -f $$module ]; then \
	 echo "$$module failed to build!"; \
	 exit 1; \
	elif [ -f split-object-file.sh ]; then \
	 /bin/sh split-object-file.sh $$module; \
	fi; \
	done


#
# Sign the NVIDIA kernel module(s) with the provided key.
#

module-sign: module
	@for module in $(MODULE_OBJECTS); do \
	 if [ -z "$(MODSECKEY)" ] || [ -z "$(MODPUBKEY)" ]; then \
	 echo "ERROR: MODSECKEY and MODPUBKEY must be set to sign modules!"; \
	 exit 1; \
	 elif ! [ -f "$(MODSECKEY)" ]; then \
	 echo "ERROR: cant find MODSECKEY \"$(MODSECKEY)\""; \
	 exit 1; \
	 elif ! [ -f "$(MODPUBKEY)" ]; then \
	 echo "ERROR: can't find MODPUBKEY \"$(MODPUBKEY)\""; \
	 exit 1; \
	 elif ! [ -x "$(MOD_SIGN_CMD)" ]; then \
	 echo "ERROR: \"$(MOD_SIGN_CMD)\" not executable!"; \
	 exit 1; \
	 fi; \
	 HASH=$(CONFIG_MODULE_SIG_HASH); \
	 if [ -z "$$HASH" ]; then \
	 HASH=$$($(CONFTEST) guess_module_signing_hash | sed s/\"//g); \
	 fi; \
	 if [ $$? -eq 0 ] && [ -n $$HASH ]; then \
	 "$(MOD_SIGN_CMD)" $$HASH "$(MODSECKEY)" "$(MODPUBKEY)" \
 "$$module"; \
	 if [ $$? -ne 0 ]; then \
	 "$(MOD_SIGN_CMD)" "$(MODSECKEY)" "$(MODPUBKEY)" "$$module"; \
	 fi; \
	 fi; \
	done

#
# Build the NVIDIA kernel module with KBUILD. Verify that the user posesses
# sufficient privileges. Rebuild the module dependency file.
#

module-install: suser-sanity-check module
	@mkdir -p $(MODULE_ROOT)/video; \
	install -m 0664 -o root -g root $(MODULE_OBJECTS) $(MODULE_ROOT)/video; \
	PATH="$(PATH):/bin:/sbin" depmod -a

#
# This target builds, then installs, then creates device nodes and inserts
# the module, if successful.
#

package-install: module-install rmmod-sanity-check
	@PATH="$(PATH):/bin:/sbin" modprobe $(MODULE_NAME) && \
	echo "$(MODULE_OBJECTS) installed successfully.";

#
# Check if the linker script module-common.lds exists. If it does, pass that
# as a linker option (via variable MODULE_COMMON_SCRIPT) while building the 
# kernel interface file. This script does some processing on the module symbols
# on which the Linux kernel's module resolution is dependent and hence must be 
# used whenever present.
#

LD_SCRIPT ?= $(KERNEL_SOURCES)/scripts/module-common.lds
MODULE_COMMON_SCRIPT := $(if $(wildcard $(LD_SCRIPT)),-T $(LD_SCRIPT))

#
# Build an object file suitable for further processing by the installer
# and inclusion as a precompiled kernel interface file. Note the
# dependency on 'module', and not just the input object files. This is
# because we rely on KBUILD to produce the latter as part of the
# full kernel module build.
#

$(KERNEL_GLUE_NAME): module
	@$(LD) $(EXTRA_LDFLAGS) $(MODULE_COMMON_SCRIPT) -r -o $(KERNEL_GLUE_NAME) $(KERNEL_GLUE_OBJS)

#
# Support hack, KBUILD isn't prepared to clean up after external modules.
#

clean:
	@$(RM) -f $(MODULE_GLUE_OBJS) $(KERNEL_GLUE_OBJS)
	@$(RM) -f build-in.o nv-linux*.o *.d .*.cmd .*.flags
	@$(RM) -f $(MODULE_NAME)*.o $(MODULE_NAME)*.ko*
	@$(RM) -f $(MODULE_NAME)*.mod* $(VERSION_HEADER) *~
	@$(RM) -f conftest*.c
	@$(RM) -rf conftest
	@$(RM) -rf Module*.symvers .tmp_versions modules.order
